/*
 * led_mlp101c.c
 *
 *  Created on: 2015. 2. 8.
 *      Author: hcshin
 */
#include <led_mlp101c.h>

// power indicator LED
#define LED1_PIN                         GPIO_Pin_4
#define LED1_GPIO_PORT                   GPIOE
#define LED1_GPIO_CLK                    RCC_APB2Periph_GPIOE
#define LED2_PIN                         GPIO_Pin_5
#define LED2_GPIO_PORT                   GPIOE
#define LED2_GPIO_CLK                    RCC_APB2Periph_GPIOE
// debugging led
#define LED3_PIN                         GPIO_Pin_6
#define LED3_GPIO_PORT                   GPIOE
#define LED3_GPIO_CLK                    RCC_APB2Periph_GPIOE


void led_init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;

  /* Enable the GPIO_LED Clock */
  RCC_APB2PeriphClockCmd(LED1_GPIO_CLK, ENABLE);

  /* Configure the GPIO_LED pin */
  GPIO_InitStructure.GPIO_Pin = LED1_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);

  /* Enable the GPIO_LED Clock */
  RCC_APB2PeriphClockCmd(LED2_GPIO_CLK, ENABLE);
  /* Configure the GPIO_LED pin */
  GPIO_InitStructure.GPIO_Pin = LED2_PIN;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);

  // debugging led
  /* Enable the GPIO_LED Clock */
  RCC_APB2PeriphClockCmd(LED3_GPIO_CLK, ENABLE);
  /* Configure the GPIO_LED pin */
  GPIO_InitStructure.GPIO_Pin = LED3_PIN;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

  GPIO_WriteBit(LED1_GPIO_PORT, LED1_PIN, Bit_RESET);
  GPIO_WriteBit(LED2_GPIO_PORT, LED2_PIN, Bit_RESET);
  GPIO_WriteBit(LED3_GPIO_PORT, LED3_PIN, Bit_RESET);
}

void led_set(LED_COLOR color)
{
  switch(color)
  {
    case LED_OFF:
      GPIO_WriteBit(LED1_GPIO_PORT, LED1_PIN, Bit_RESET);
      GPIO_WriteBit(LED2_GPIO_PORT, LED2_PIN, Bit_RESET);
      break;
    case LED_RED:
      GPIO_WriteBit(LED1_GPIO_PORT, LED1_PIN, Bit_SET);
      GPIO_WriteBit(LED2_GPIO_PORT, LED2_PIN, Bit_RESET);
      break;
    case LED_GREEN:
      GPIO_WriteBit(LED1_GPIO_PORT, LED1_PIN, Bit_RESET);
      GPIO_WriteBit(LED2_GPIO_PORT, LED2_PIN, Bit_SET);
      break;
    case LED_AMBER:
      GPIO_WriteBit(LED1_GPIO_PORT, LED1_PIN, Bit_SET);
      GPIO_WriteBit(LED2_GPIO_PORT, LED2_PIN, Bit_SET);
      break;
  }
}

void led_debug_on(void)
{
  GPIO_WriteBit(LED3_GPIO_PORT, LED3_PIN, Bit_SET);
}

void led_debug_off(void)
{
  GPIO_WriteBit(LED3_GPIO_PORT, LED3_PIN, Bit_RESET);
}

void led_debug_toggle(void)
{
  if(GPIO_ReadOutputDataBit(LED3_GPIO_PORT, LED3_PIN) == Bit_SET)
	led_debug_off();
  else
	led_debug_on();
}
